# Ipopt::Matrix Class Reference

Matrix Base Class. More...

`#include <IpMatrix.hpp>`

Inheritance diagram for Ipopt::Matrix:
[legend]

List of all members.

## Public Member Functions
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace.
Constructor/Destructor
| Matrix (const MatrixSpace *owner_space)
| Constructor.
virtual | ~Matrix ()
| Destructor.
Operations of the Matrix on a Vector
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply.
Methods for specialized operations. A prototype
implementation is provided, but for efficient implementation those should be specially implemented.
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z).
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td).
Information about the size of the matrix
Index | NRows () const
| Number of rows.
Index | NCols () const
| Number of columns.
Norms of the individual rows and columns
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix.
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix.
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix.
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
## Protected Member Functions
implementation methods (derived classes MUST
overload these pure virtual protected methods.
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const =0
| Matrix-vector multiply.
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const =0
| Matrix(transpose) vector multiply.
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z).
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td).
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const =0
| Compute the max-norm of the rows in the matrix.
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const =0
| Compute the max-norm of the columns in the matrix.
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const =0
| Print detailed information about the matrix.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| Matrix ()
| default constructor
| Matrix (const Matrix &)
| Copy constructor.
Matrix & | operator= (const Matrix &)
| Overloaded Equals Operator.
## Private Attributes
const SmartPtr< const MatrixSpace > | owner_space_
CachedResults data members
TaggedObject::Tag | valid_cache_tag_
bool | cached_valid_

## Detailed Description

Matrix Base Class.

This is the base class for all derived matrix types. All Matrices, such as Jacobian and Hessian matrices, as well as possibly the iteration matrices needed for the step computation, are of this type.

Deriving from Matrix: Overload the protected XXX_Impl method.

Definition at line 27 of file IpMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::Matrix::Matrix | ( | const MatrixSpace * | owner_space | ) | `[inline]`

Constructor.

It has to be given a pointer to the corresponding MatrixSpace.

Definition at line 35 of file IpMatrix.hpp.

virtual Ipopt::Matrix::~Matrix | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 43 of file IpMatrix.hpp.

Ipopt::Matrix::Matrix | ( |  | ) | `[private]`

default constructor

Ipopt::Matrix::Matrix | ( | const Matrix & |  | ) | `[private]`

Copy constructor.

## Member Function Documentation

void Ipopt::Matrix::MultVector | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[inline]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y. Do not overload. Overload MultVectorImpl instead.

Definition at line 52 of file IpMatrix.hpp.

void Ipopt::Matrix::TransMultVector | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[inline]`

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y. Do not overload. Overload TransMultVectorImpl instead.

Definition at line 62 of file IpMatrix.hpp.

void Ipopt::Matrix::AddMSinvZ | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | Z,
|  | Vector & | X |
| ) |  |  | const

X = X + alpha*(Matrix S^{-1} Z).

Should be implemented efficiently for the ExansionMatrix

void Ipopt::Matrix::SinvBlrmZMTdBr | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | R,
|  | const Vector & | Z,
|  | const Vector & | D,
|  | Vector & | X |
| ) |  |  | const

X = S^{-1} (r + alpha*Z*M^Td).

Should be implemented efficiently for the ExansionMatrix

bool Ipopt::Matrix::HasValidNumbers | ( |  | ) | const

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Index Ipopt::Matrix::NRows | ( |  | ) | const`[inline]`

Number of rows.

Definition at line 310 of file IpMatrix.hpp.

Index Ipopt::Matrix::NCols | ( |  | ) | const`[inline]`

Number of columns.

Definition at line 316 of file IpMatrix.hpp.

void Ipopt::Matrix::ComputeRowAMax | ( | Vector & | rows_norms,
|  | bool | init = `true` |
| ) |  |  | const`[inline]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized of init is false.

Definition at line 108 of file IpMatrix.hpp.

void Ipopt::Matrix::ComputeColAMax | ( | Vector & | cols_norms,
|  | bool | init = `true` |
| ) |  |  | const`[inline]`

Compute the max-norm of the columns in the matrix.

The result is stored in cols_norms The vector is assumed to be initialized of init is false.

Definition at line 117 of file IpMatrix.hpp.

virtual void Ipopt::Matrix::Print | ( | SmartPtr< const Journalist > | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent = `0`,
|  | const std::string & | prefix = `""` |
| ) |  |  | const`[virtual]`

Print detailed information about the matrix.

Do not overload. Overload PrintImpl instead.

virtual void Ipopt::Matrix::Print | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent = `0`,
|  | const std::string & | prefix = `""` |
| ) |  |  | const`[virtual]`

SmartPtr< const MatrixSpace > Ipopt::Matrix::OwnerSpace | ( |  | ) | const`[inline]`

Return the owner MatrixSpace.

Definition at line 322 of file IpMatrix.hpp.

virtual void Ipopt::Matrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, pure virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implemented in Ipopt::CompoundMatrix, Ipopt::CompoundSymMatrix, Ipopt::DenseGenMatrix, Ipopt::DenseSymMatrix, Ipopt::DiagMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::ExpansionMatrix, Ipopt::IdentityMatrix, Ipopt::LowRankUpdateSymMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SumSymMatrix, Ipopt::SymScaledMatrix, Ipopt::TransposeMatrix, Ipopt::ZeroMatrix, Ipopt::GenTMatrix, and Ipopt::SymTMatrix.

virtual void Ipopt::Matrix::TransMultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, pure virtual]`

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y

Implemented in Ipopt::CompoundMatrix, Ipopt::DenseGenMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::ExpansionMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SymMatrix, Ipopt::TransposeMatrix, Ipopt::ZeroMatrix, and Ipopt::GenTMatrix.

virtual void Ipopt::Matrix::AddMSinvZImpl | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | Z,
|  | Vector & | X |
| ) |  |  | const`[protected, virtual]`

X = X + alpha*(Matrix S^{-1} Z).

Prototype for this specialize method is provided, but for efficient implementation it should be overloaded for the expansion matrix.

Reimplemented in Ipopt::CompoundMatrix, Ipopt::ExpansionMatrix, Ipopt::IdentityMatrix, and Ipopt::ScaledMatrix.

virtual void Ipopt::Matrix::SinvBlrmZMTdBrImpl | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | R,
|  | const Vector & | Z,
|  | const Vector & | D,
|  | Vector & | X |
| ) |  |  | const`[protected, virtual]`

X = S^{-1} (r + alpha*Z*M^Td).

Should be implemented efficiently for the ExpansionMatrix.

Reimplemented in Ipopt::CompoundMatrix, Ipopt::ExpansionMatrix, and Ipopt::ScaledMatrix.

virtual bool Ipopt::Matrix::HasValidNumbersImpl | ( |  | ) | const`[inline, protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

A default implementation always returning true is provided, but if possible it should be implemented.

Reimplemented in Ipopt::CompoundMatrix, Ipopt::CompoundSymMatrix, Ipopt::DenseGenMatrix, Ipopt::DenseSymMatrix, Ipopt::DiagMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::IdentityMatrix, Ipopt::LowRankUpdateSymMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SumSymMatrix, Ipopt::SymScaledMatrix, Ipopt::TransposeMatrix, Ipopt::GenTMatrix, and Ipopt::SymTMatrix.

Definition at line 179 of file IpMatrix.hpp.

virtual void Ipopt::Matrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init |
| ) |  |  | const`[protected, pure virtual]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implemented in Ipopt::CompoundMatrix, Ipopt::CompoundSymMatrix, Ipopt::DenseGenMatrix, Ipopt::DenseSymMatrix, Ipopt::DiagMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::ExpansionMatrix, Ipopt::IdentityMatrix, Ipopt::LowRankUpdateSymMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SumSymMatrix, Ipopt::SymScaledMatrix, Ipopt::TransposeMatrix, Ipopt::ZeroMatrix, Ipopt::GenTMatrix, and Ipopt::SymTMatrix.

virtual void Ipopt::Matrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init |
| ) |  |  | const`[protected, pure virtual]`

Compute the max-norm of the columns in the matrix.

The result is stored in cols_norms. The vector is assumed to be initialized.

Implemented in Ipopt::CompoundMatrix, Ipopt::DenseGenMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::ExpansionMatrix, Ipopt::LowRankUpdateSymMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SumSymMatrix, Ipopt::SymMatrix, Ipopt::TransposeMatrix, Ipopt::ZeroMatrix, and Ipopt::GenTMatrix.

virtual void Ipopt::Matrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, pure virtual]`

Print detailed information about the matrix.

Implemented in Ipopt::CompoundMatrix, Ipopt::CompoundSymMatrix, Ipopt::DenseGenMatrix, Ipopt::DenseSymMatrix, Ipopt::DiagMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::ExpansionMatrix, Ipopt::IdentityMatrix, Ipopt::LowRankUpdateSymMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SumSymMatrix, Ipopt::SymScaledMatrix, Ipopt::TransposeMatrix, Ipopt::ZeroMatrix, Ipopt::GenTMatrix, and Ipopt::SymTMatrix.

Matrix& Ipopt::Matrix::operator= | ( | const Matrix & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::TaggedObject.

Reimplemented in Ipopt::CompoundMatrix, Ipopt::CompoundSymMatrix, Ipopt::DenseGenMatrix, Ipopt::DenseSymMatrix, Ipopt::DiagMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::ExpansionMatrix, Ipopt::IdentityMatrix, Ipopt::LowRankUpdateSymMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SumSymMatrix, Ipopt::SymScaledMatrix, Ipopt::TransposeMatrix, Ipopt::ZeroMatrix, Ipopt::GenTMatrix, and Ipopt::SymTMatrix.

## Member Data Documentation

const SmartPtr<const MatrixSpace> Ipopt::Matrix::owner_space_`[private]`

Reimplemented in Ipopt::CompoundMatrix, Ipopt::CompoundSymMatrix, Ipopt::DenseGenMatrix, Ipopt::DenseSymMatrix, Ipopt::ExpandedMultiVectorMatrix, Ipopt::ExpansionMatrix, Ipopt::LowRankUpdateSymMatrix, Ipopt::MultiVectorMatrix, Ipopt::ScaledMatrix, Ipopt::SumMatrix, Ipopt::SumSymMatrix, Ipopt::SymMatrix, Ipopt::SymScaledMatrix, Ipopt::GenTMatrix, and Ipopt::SymTMatrix.

Definition at line 221 of file IpMatrix.hpp.

TaggedObject::Tag Ipopt::Matrix::valid_cache_tag_`[mutable, private]`

Definition at line 225 of file IpMatrix.hpp.

bool Ipopt::Matrix::cached_valid_`[mutable, private]`

Definition at line 226 of file IpMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpMatrix.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines